Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/linalg.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/linalg.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/linalg.cs	(revision 7294)
@@ -1328,9 +1328,9 @@
                     Array whose indexes range within [0..N-1, 0..N-1].
         N       -   size of matrix A.
-        IsUpper -   storage format.
         ZNeeded -   flag controlling whether the eigenvectors are needed or not.
                     If ZNeeded is equal to:
                      * 0, the eigenvectors are not returned;
                      * 1, the eigenvectors are returned.
+        IsUpper -   storage format.
 
     Output parameters:
@@ -10960,9 +10960,9 @@
                         Array whose indexes range within [0..N-1, 0..N-1].
             N       -   size of matrix A.
-            IsUpper -   storage format.
             ZNeeded -   flag controlling whether the eigenvectors are needed or not.
                         If ZNeeded is equal to:
                          * 0, the eigenvectors are not returned;
                          * 1, the eigenvectors are returned.
+            IsUpper -   storage format.
 
         Output parameters:
@@ -17368,4 +17368,17 @@
     public class matgen
     {
+        /*************************************************************************
+        Generation of a random uniformly distributed (Haar) orthogonal matrix
+
+        INPUT PARAMETERS:
+            N   -   matrix size, N>=1
+            
+        OUTPUT PARAMETERS:
+            A   -   orthogonal NxN matrix, array[0..N-1,0..N-1]
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixrndorthogonal(int n,
             ref double[,] a)
@@ -17396,4 +17409,18 @@
 
 
+        /*************************************************************************
+        Generation of random NxN matrix with given condition number and norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixrndcond(int n,
             double c,
@@ -17438,4 +17465,17 @@
 
 
+        /*************************************************************************
+        Generation of a random Haar distributed orthogonal complex matrix
+
+        INPUT PARAMETERS:
+            N   -   matrix size, N>=1
+
+        OUTPUT PARAMETERS:
+            A   -   orthogonal NxN matrix, array[0..N-1,0..N-1]
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void cmatrixrndorthogonal(int n,
             ref complex[,] a)
@@ -17466,4 +17506,19 @@
 
 
+        /*************************************************************************
+        Generation of random NxN complex matrix with given condition number C and
+        norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void cmatrixrndcond(int n,
             double c,
@@ -17512,4 +17567,19 @@
 
 
+        /*************************************************************************
+        Generation of random NxN symmetric matrix with given condition number  and
+        norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void smatrixrndcond(int n,
             double c,
@@ -17561,4 +17631,19 @@
 
 
+        /*************************************************************************
+        Generation of random NxN symmetric positive definite matrix with given
+        condition number and norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random SPD matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void spdmatrixrndcond(int n,
             double c,
@@ -17613,4 +17698,19 @@
 
 
+        /*************************************************************************
+        Generation of random NxN Hermitian matrix with given condition number  and
+        norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void hmatrixrndcond(int n,
             double c,
@@ -17670,4 +17770,19 @@
 
 
+        /*************************************************************************
+        Generation of random NxN Hermitian positive definite matrix with given
+        condition number and norm2(A)=1
+
+        INPUT PARAMETERS:
+            N   -   matrix size
+            C   -   condition number (in 2-norm)
+
+        OUTPUT PARAMETERS:
+            A   -   random HPD matrix with norm2(A)=1 and cond(A)=C
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void hpdmatrixrndcond(int n,
             double c,
@@ -17730,4 +17845,18 @@
 
 
+        /*************************************************************************
+        Multiplication of MxN matrix by NxN random Haar distributed orthogonal matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..M-1, 0..N-1]
+            M, N-   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   A*Q, where Q is random NxN orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixrndorthogonalfromtheright(ref double[,] a,
             int m,
@@ -17816,4 +17945,18 @@
 
 
+        /*************************************************************************
+        Multiplication of MxN matrix by MxM random Haar distributed orthogonal matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..M-1, 0..N-1]
+            M, N-   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   Q*A, where Q is random MxM orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixrndorthogonalfromtheleft(ref double[,] a,
             int m,
@@ -17903,4 +18046,19 @@
 
 
+        /*************************************************************************
+        Multiplication of MxN complex matrix by NxN random Haar distributed
+        complex orthogonal matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..M-1, 0..N-1]
+            M, N-   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   A*Q, where Q is random NxN orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void cmatrixrndorthogonalfromtheright(ref complex[,] a,
             int m,
@@ -17982,4 +18140,19 @@
 
 
+        /*************************************************************************
+        Multiplication of MxN complex matrix by MxM random Haar distributed
+        complex orthogonal matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..M-1, 0..N-1]
+            M, N-   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   Q*A, where Q is random MxM orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void cmatrixrndorthogonalfromtheleft(ref complex[,] a,
             int m,
@@ -18062,4 +18235,19 @@
 
 
+        /*************************************************************************
+        Symmetric multiplication of NxN matrix by random Haar distributed
+        orthogonal  matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..N-1, 0..N-1]
+            N   -   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   Q'*A*Q, where Q is random NxN orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void smatrixrndmultiply(ref double[,] a,
             int n)
@@ -18137,4 +18325,19 @@
 
 
+        /*************************************************************************
+        Hermitian multiplication of NxN matrix by random Haar distributed
+        complex orthogonal matrix
+
+        INPUT PARAMETERS:
+            A   -   matrix, array[0..N-1, 0..N-1]
+            N   -   matrix size
+
+        OUTPUT PARAMETERS:
+            A   -   Q^H*A*Q, where Q is random NxN orthogonal matrix
+
+          -- ALGLIB routine --
+             04.12.2009
+             Bochkanov Sergey
+        *************************************************************************/
         public static void hmatrixrndmultiply(ref complex[,] a,
             int n)
@@ -24752,4 +24955,82 @@
     public class bdsvd
     {
+        /*************************************************************************
+        Singular value decomposition of a bidiagonal matrix (extended algorithm)
+
+        The algorithm performs the singular value decomposition  of  a  bidiagonal
+        matrix B (upper or lower) representing it as B = Q*S*P^T, where Q and  P -
+        orthogonal matrices, S - diagonal matrix with non-negative elements on the
+        main diagonal, in descending order.
+
+        The  algorithm  finds  singular  values.  In  addition,  the algorithm can
+        calculate  matrices  Q  and P (more precisely, not the matrices, but their
+        product  with  given  matrices U and VT - U*Q and (P^T)*VT)).  Of  course,
+        matrices U and VT can be of any type, including identity. Furthermore, the
+        algorithm can calculate Q'*C (this product is calculated more  effectively
+        than U*Q,  because  this calculation operates with rows instead  of matrix
+        columns).
+
+        The feature of the algorithm is its ability to find  all  singular  values
+        including those which are arbitrarily close to 0  with  relative  accuracy
+        close to  machine precision. If the parameter IsFractionalAccuracyRequired
+        is set to True, all singular values will have high relative accuracy close
+        to machine precision. If the parameter is set to False, only  the  biggest
+        singular value will have relative accuracy  close  to  machine  precision.
+        The absolute error of other singular values is equal to the absolute error
+        of the biggest singular value.
+
+        Input parameters:
+            D       -   main diagonal of matrix B.
+                        Array whose index ranges within [0..N-1].
+            E       -   superdiagonal (or subdiagonal) of matrix B.
+                        Array whose index ranges within [0..N-2].
+            N       -   size of matrix B.
+            IsUpper -   True, if the matrix is upper bidiagonal.
+            IsFractionalAccuracyRequired -
+                        accuracy to search singular values with.
+            U       -   matrix to be multiplied by Q.
+                        Array whose indexes range within [0..NRU-1, 0..N-1].
+                        The matrix can be bigger, in that case only the  submatrix
+                        [0..NRU-1, 0..N-1] will be multiplied by Q.
+            NRU     -   number of rows in matrix U.
+            C       -   matrix to be multiplied by Q'.
+                        Array whose indexes range within [0..N-1, 0..NCC-1].
+                        The matrix can be bigger, in that case only the  submatrix
+                        [0..N-1, 0..NCC-1] will be multiplied by Q'.
+            NCC     -   number of columns in matrix C.
+            VT      -   matrix to be multiplied by P^T.
+                        Array whose indexes range within [0..N-1, 0..NCVT-1].
+                        The matrix can be bigger, in that case only the  submatrix
+                        [0..N-1, 0..NCVT-1] will be multiplied by P^T.
+            NCVT    -   number of columns in matrix VT.
+
+        Output parameters:
+            D       -   singular values of matrix B in descending order.
+            U       -   if NRU>0, contains matrix U*Q.
+            VT      -   if NCVT>0, contains matrix (P^T)*VT.
+            C       -   if NCC>0, contains matrix Q'*C.
+
+        Result:
+            True, if the algorithm has converged.
+            False, if the algorithm hasn't converged (rare case).
+
+        Additional information:
+            The type of convergence is controlled by the internal  parameter  TOL.
+            If the parameter is greater than 0, the singular values will have
+            relative accuracy TOL. If TOL<0, the singular values will have
+            absolute accuracy ABS(TOL)*norm(B).
+            By default, |TOL| falls within the range of 10*Epsilon and 100*Epsilon,
+            where Epsilon is the machine precision. It is not  recommended  to  use
+            TOL less than 10*Epsilon since this will  considerably  slow  down  the
+            algorithm and may not lead to error decreasing.
+        History:
+            * 31 March, 2007.
+                changed MAXITR from 6 to 12.
+
+          -- LAPACK routine (version 3.0) --
+             Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
+             Courant Institute, Argonne National Lab, and Rice University
+             October 31, 1999.
+        *************************************************************************/
         public static bool rmatrixbdsvd(ref double[] d,
             double[] e,
@@ -24818,4 +25099,7 @@
 
 
+        /*************************************************************************
+        Internal working subroutine for bidiagonal decomposition
+        *************************************************************************/
         private static bool bidiagonalsvddecompositioninternal(ref double[] d,
             double[] e,
@@ -28066,4 +28350,25 @@
     public class inverseupdate
     {
+        /*************************************************************************
+        Inverse matrix update by the Sherman-Morrison formula
+
+        The algorithm updates matrix A^-1 when adding a number to an element
+        of matrix A.
+
+        Input parameters:
+            InvA    -   inverse of matrix A.
+                        Array whose indexes range within [0..N-1, 0..N-1].
+            N       -   size of matrix A.
+            UpdRow  -   row where the element to be updated is stored.
+            UpdColumn - column where the element to be updated is stored.
+            UpdVal  -   a number to be added to the element.
+
+
+        Output parameters:
+            InvA    -   inverse of modified matrix A.
+
+          -- ALGLIB --
+             Copyright 2005 by Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixinvupdatesimple(ref double[,] inva,
             int n,
@@ -28120,4 +28425,25 @@
 
 
+        /*************************************************************************
+        Inverse matrix update by the Sherman-Morrison formula
+
+        The algorithm updates matrix A^-1 when adding a vector to a row
+        of matrix A.
+
+        Input parameters:
+            InvA    -   inverse of matrix A.
+                        Array whose indexes range within [0..N-1, 0..N-1].
+            N       -   size of matrix A.
+            UpdRow  -   the row of A whose vector V was added.
+                        0 <= Row <= N-1
+            V       -   the vector to be added to a row.
+                        Array whose index ranges within [0..N-1].
+
+        Output parameters:
+            InvA    -   inverse of modified matrix A.
+
+          -- ALGLIB --
+             Copyright 2005 by Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixinvupdaterow(ref double[,] inva,
             int n,
@@ -28173,4 +28499,25 @@
 
 
+        /*************************************************************************
+        Inverse matrix update by the Sherman-Morrison formula
+
+        The algorithm updates matrix A^-1 when adding a vector to a column
+        of matrix A.
+
+        Input parameters:
+            InvA        -   inverse of matrix A.
+                            Array whose indexes range within [0..N-1, 0..N-1].
+            N           -   size of matrix A.
+            UpdColumn   -   the column of A whose vector U was added.
+                            0 <= UpdColumn <= N-1
+            U           -   the vector to be added to a column.
+                            Array whose index ranges within [0..N-1].
+
+        Output parameters:
+            InvA        -   inverse of modified matrix A.
+
+          -- ALGLIB --
+             Copyright 2005 by Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixinvupdatecolumn(ref double[,] inva,
             int n,
@@ -28225,4 +28572,25 @@
 
 
+        /*************************************************************************
+        Inverse matrix update by the Sherman-Morrison formula
+
+        The algorithm computes the inverse of matrix A+u*v by using the given matrix
+        A^-1 and the vectors u and v.
+
+        Input parameters:
+            InvA    -   inverse of matrix A.
+                        Array whose indexes range within [0..N-1, 0..N-1].
+            N       -   size of matrix A.
+            U       -   the vector modifying the matrix.
+                        Array whose index ranges within [0..N-1].
+            V       -   the vector modifying the matrix.
+                        Array whose index ranges within [0..N-1].
+
+        Output parameters:
+            InvA - inverse of matrix A + u*v'.
+
+          -- ALGLIB --
+             Copyright 2005 by Bochkanov Sergey
+        *************************************************************************/
         public static void rmatrixinvupdateuv(ref double[,] inva,
             int n,
@@ -28290,4 +28658,44 @@
     public class schur
     {
+        /*************************************************************************
+        Subroutine performing the Schur decomposition of a general matrix by using
+        the QR algorithm with multiple shifts.
+
+        The source matrix A is represented as S'*A*S = T, where S is an orthogonal
+        matrix (Schur vectors), T - upper quasi-triangular matrix (with blocks of
+        sizes 1x1 and 2x2 on the main diagonal).
+
+        Input parameters:
+            A   -   matrix to be decomposed.
+                    Array whose indexes range within [0..N-1, 0..N-1].
+            N   -   size of A, N>=0.
+
+
+        Output parameters:
+            A   -   contains matrix T.
+                    Array whose indexes range within [0..N-1, 0..N-1].
+            S   -   contains Schur vectors.
+                    Array whose indexes range within [0..N-1, 0..N-1].
+
+        Note 1:
+            The block structure of matrix T can be easily recognized: since all
+            the elements below the blocks are zeros, the elements a[i+1,i] which
+            are equal to 0 show the block border.
+
+        Note 2:
+            The algorithm performance depends on the value of the internal parameter
+            NS of the InternalSchurDecomposition subroutine which defines the number
+            of shifts in the QR algorithm (similarly to the block width in block-matrix
+            algorithms in linear algebra). If you require maximum performance on
+            your machine, it is recommended to adjust this parameter manually.
+
+        Result:
+            True,
+                if the algorithm has converged and parameters A and S contain the result.
+            False,
+                if the algorithm has not converged.
+
+        Algorithm implemented on the basis of the DHSEQR subroutine (LAPACK 3.0 library).
+        *************************************************************************/
         public static bool rmatrixschur(ref double[,] a,
             int n,
